package wdp63;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;

import java.util.ArrayList;

import org.junit.Before;
import org.junit.Test;

public class XUnitPrimer {
    private ArrayList<String> list;

    @Before
    public void 前準備() throws Exception {
        list = new ArrayList<String>();
    }

    @Test
    public void インスタンス化直後のList() throws Exception {
        // 検証
        assertThat(list.isEmpty(), is(true));
        assertThat(list.size(), is(1)); //わざと失敗を残す
    }

    @Test
    public void 要素を2つ入れたリスト() throws Exception {
        // 実行
        list.add("foo");
        list.add("bar");
        // 検証
        assertThat(list.isEmpty(), is(false));
        assertThat(list.size(), is(2));
        assertThat(list.indexOf("bar"), is(1));
    }

    @Test
    public void 要素を2つ入れた後最初の要素を削除した場合()
          throws Exception {
        // 準備(の続き)
        list.add("foo");
        list.add("bar");
        // 実行
        list.remove("foo");
        // 検証
        assertThat(list.size(), is(1));
        assertThat(list.indexOf("bar"), is(0));
    }
}
