package wdp63;

import static org.junit.Assert.assertTrue;

import java.util.ArrayList;

import org.junit.Test;

public class XUnitPrimer { 
    @Test 
    public void Listの振る舞いテスト() throws Exception {
        ArrayList<String> list = new ArrayList<String>();
        System.out.println("# インスタンス化直後");
        assertTrue(list.isEmpty());
        assertTrue(list.size() == 1);

        System.out.println("# foo,barの順にaddする");
        list.add("foo");
        list.add("bar");
        assertTrue(!list.isEmpty());
        assertTrue(list.size() == 2);
        assertTrue(list.indexOf("bar") == 1);

        System.out.println("# fooをremoveする");
        list.remove("foo");
        assertTrue(list.size() == 1);
        assertTrue(list.indexOf("bar") == 0); 
    }
}
